Index: /trunk/src/objects/RpNumber.cc
===================================================================
--- /trunk/src/objects/RpNumber.cc	(revision 1269)
+++ /trunk/src/objects/RpNumber.cc	(revision 1270)
@@ -5,5 +5,5 @@
  * ======================================================================
  *  AUTHOR:  Derrick Kearney, Purdue University
- *  Copyright (c) 2004-2005  Purdue Research Foundation
+ *  Copyright (c) 2005-2009  Purdue Research Foundation
  *
  *  See the file "license.terms" for information on usage and
@@ -12,138 +12,117 @@
  */
 
+#include <cstring>
+#include <stdlib.h>
 #include "RpNumber.h"
 
-/**********************************************************************/
-// METHOD: setDefaultValue()
-/// set the default value of a RpNumber object.
-/**
- */
+#ifndef _RpUNITS_H
+    #include "RpUnits.h"
+#endif
 
-RpNumber&
-RpNumber::setDefaultValue(double newDefaultVal) {
+RpNumber::RpNumber (
+            const char *path,
+            const char *unit,
+            double val
+        )
+    :   RpVariable  (),
+        _default    (val),
+        _current    (val),
+        _min        (0.0),
+        _max        (0.0),
+        _minmaxSet  (0.0)
+{
+    const RpUnits *u = NULL;
 
-    double* def = NULL;
+    property("path",(const void *)path);
 
-    def = (double*) RpVariable::getDefaultValue(); 
+    u = RpUnits::find(std::string(unit));
+    if (!u) {
+        u = RpUnits::define(unit,NULL);
+    }
+    property("units",(const void *)unit);
 
-    if (!def) {
-        RpVariable::setDefaultValue(new double (newDefaultVal));
+    property("default",(const void *)&_default);
+    property("current",(const void *)&_current);
+    property("min",(const void *)&_min);
+    property("max",(const void *)&_max);
+}
+
+RpNumber::RpNumber (
+            const char *path,
+            const char *unit,
+            double val,
+            double min,
+            double max,
+            const char *label,
+            const char *desc
+        )
+    :   RpVariable  (),
+        _default    (val),
+        _current    (val),
+        _min         (min),
+        _max         (max),
+        _minmaxSet   (0)
+{
+    const RpUnits *u = NULL;
+
+    property("path",(const void *)path);
+
+    u = RpUnits::find(std::string(unit));
+    if (! u) {
+        u = RpUnits::define(unit,NULL);
+    }
+    property("units",(const void *)unit);
+
+    if ((min == 0) && (max == 0)) {
+        _minmaxSet = 0;
     }
     else {
-        *def = newDefaultVal;
+
+        if (min > val) {
+            _min = val;
+        }
+
+        if (max < val) {
+            _max = val;
+        }
     }
 
-    return *this;
+    property("default",(const void *)&_default);
+    property("current",(const void *)&_current);
+    property("min",(const void *)&_min);
+    property("max",(const void *)&_max);
+}
+
+// copy constructor
+RpNumber::RpNumber ( const RpNumber& o )
+    :   RpVariable(o),
+        _default    (o._default),
+        _current    (o._current),
+        _min        (o._min),
+        _max        (o._max),
+        _minmaxSet  (o._minmaxSet)
+{}
+
+// default destructor
+RpNumber::~RpNumber ()
+{
+    // clean up dynamic memory
+
 }
 
 /**********************************************************************/
-// METHOD: setCurrentValue()
-/// Set the current value of a RpNumber object.
+// METHOD: units()
+/// get / set the units of this number
 /**
+ * get / set the units property of this object
  */
 
-RpNumber&
-RpNumber::setCurrentValue(double newCurrentVal) {
-
-    double* cur = (double*) RpVariable::getCurrentValue();
-    double* def = (double*) RpVariable::getDefaultValue();
-
-    if (cur == def) {
-        RpVariable::setCurrentValue(new double (newCurrentVal));
-    }
-    else {
-        *cur = newCurrentVal;
-    }
-
-    return *this;
+const char *
+RpNumber::units(
+    const char *val)
+{
+    return (const char *) property("units",val);
 }
 
-
-/**********************************************************************/
-// METHOD: setMin()
-/// Set the min value of a RpNumber object.
-/**
- */
-
-RpNumber&
-RpNumber::setMin(double newMin) {
-
-    min = newMin;
-    return *this;
-}
-
-/**********************************************************************/
-// METHOD: setMax()
-/// set the min value of a RpNumber object
-/**
- */
-
-RpNumber&
-RpNumber::setMax(double newMax) {
-
-    max = newMax;
-    return *this;
-}
-
-/**********************************************************************/
-// METHOD: getUnits()
-/// Report the units of the object.
-/**
- */
-
-std::string 
-RpNumber::getUnits() const {
-
-    return units->getUnitsName(); 
-}
-
-
-/**********************************************************************/
-// METHOD: getDefaultValue()
-/// Report the default value of the object.
-/**
- */
-
-double
-RpNumber::getDefaultValue(void* null_val) const {
-
-    return *((double*) RpVariable::getDefaultValue()); 
-}
-
-/**********************************************************************/
-// METHOD: getCurrentValue()
-/// Report the current value of the object.
-/**
- */
-
-double
-RpNumber::getCurrentValue(void* null_val) const {
-
-    return *((double*) RpVariable::getCurrentValue()); 
-}
-
-/**********************************************************************/
-// METHOD: getMin()
-/// Report the min of the object.
-/**
- */
-
-double
-RpNumber::getMin() const {
-
-    return min;
-}
-
-/**********************************************************************/
-// METHOD: getMax()
-/// report the max of the object.
-/**
- */
-
-double
-RpNumber::getMax() const {
-
-    return max;
-}
 
 /**********************************************************************/
@@ -155,91 +134,43 @@
 
 double
-RpNumber::convert(std::string toUnitStr, int storeResult, int* result) {
+RpNumber::convert(const char *to) {
 
     const RpUnits* toUnit = NULL;
-    double retVal = 0;
-    int my_result = 0;
+    const RpUnits* fromUnit = NULL;
+    double convertedVal = _current;
+    int err = 0;
 
-    toUnit = RpUnits::find(toUnitStr);
-
-    // set the result to the default value if it exists
-    if (result) {
-        *result = my_result;
+    // make sure all units functions accept char*'s
+    toUnit = RpUnits::find(std::string(to));
+    if (!toUnit) {
+        // should raise error!
+        // conversion not defined because unit does not exist
+        return _current;
     }
 
-    if (!toUnit) {
-        // should raise error! 
+    fromUnit = RpUnits::find(std::string(units(NULL)));
+    if (!fromUnit) {
+        // should raise error!
         // conversion not defined because unit does not exist
-        return retVal;
+        return _current;
     }
 
     // perform the conversion
-    retVal = convert(toUnit,&my_result); 
-
-    // check the result of the conversion and store if necessary
-    if (my_result) {
-        if (result) {
-            *result = my_result;
-        }
-
-        // check if we should store the value and change units
-        if (storeResult) {
-            // no need to deallocate old units, 
-            // because they are stored in static dictionary
-            units = toUnit;
-            RpNumber::setCurrentValue(retVal);
-        }
+    convertedVal = fromUnit->convert(toUnit,_default, &err);
+    if (!err) {
+        _default = convertedVal;
     }
 
-    return retVal;
+    convertedVal = fromUnit->convert(toUnit,_current, &err);
+    if (!err) {
+        _current = convertedVal;
+    }
+
+    if (err) {
+        convertedVal = _current;
+    }
+
+    return convertedVal;
 }
-
-/**********************************************************************/
-// METHOD: convert()
-/// Convert the number object to another unit from string.
-/**
- */
-
-double
-RpNumber::convert(std::string toUnitStr, int* result) {
-
-    const RpUnits* toUnit = NULL;
-    toUnit = RpUnits::find(toUnitStr);
-    if (!toUnit) {
-        // should raise error! 
-        // conversion not defined because unit does not exist
-        if (result) {
-            *result = -1;
-        }
-        return 0.0;
-    }
-    return convert(toUnit, result); 
-}
-
-/**********************************************************************/
-// METHOD: convert()
-/// Convert the number object to another unit from RpUnits object.
-/**
- */
-
-double
-RpNumber::convert(const RpUnits* toUnit, int *result) {
-
-    return units->convert(toUnit,getCurrentValue(), result); 
-}
-
-/**********************************************************************/
-// METHOD: put()
-/// Store the information of this Rappture Object into the xml
-/**
- */
-//
-//RpNumber&
-//RpNumber::put() const {
-//
-//    
-//    return *this; 
-//}
-
 
 // -------------------------------------------------------------------- //
Index: /trunk/src/objects/RpNumber.h
===================================================================
--- /trunk/src/objects/RpNumber.h	(revision 1269)
+++ /trunk/src/objects/RpNumber.h	(revision 1270)
@@ -1,5 +1,6 @@
 /*
  * ======================================================================
- *  Copyright (c) 2004-2005  Purdue Research Foundation
+ *  AUTHOR:  Derrick Kearney, Purdue University
+ *  Copyright (c) 2005-2009  Purdue Research Foundation
  *
  *  See the file "license.terms" for information on usage and
@@ -7,12 +8,5 @@
  * ======================================================================
  */
-#include <iostream>
-#include <string>
-#include <sstream>
-#include <stdlib.h>
 #include <errno.h>
-
-
-// #include "RpLibrary.h"
 
 #ifndef _RpVARIABLE_H
@@ -20,9 +14,5 @@
 #endif
 
-#ifndef _RpUNITS_H
-    #include "RpUnits.h"
-#endif
-
-#ifndef _RpNUMBER_H 
+#ifndef _RpNUMBER_H
 #define _RpNUMBER_H
 
@@ -31,144 +21,36 @@
     public:
 
-        // users member fxns
+        RpNumber (  const char *path,
+                    const char *unit,
+                    double val);
 
-        /*
-        virtual RpNumber& setUnits(std::string newUnits);
-        */
-
-        virtual RpNumber& setDefaultValue(double newDefaultVal);
-        virtual RpNumber& setCurrentValue(double newCurrentVal);
-        virtual RpNumber& setMin(double newMin);
-        virtual RpNumber& setMax(double newMax);
-
-        std::string getUnits() const;
-        // changed from "Value" to "Val" because base class makes 
-        // these functions virtual and derived class has a different
-        // return type. compiler doesnt like this. need to find another
-        // way around this
-        //
-        // if we keep the null_val=NULL will that give us undefined behavior?
-        //
-        double getDefaultValue(void* null_val=NULL) const;
-        double getCurrentValue(void* null_val=NULL) const;
-        double getMin() const;
-        double getMax() const;
-
-        double convert( std::string toUnitStr, 
-                        int storeResult, 
-                        int* result = NULL  );
-        double convert(std::string toUnitStr, int* result = NULL);
-        double convert(const RpUnits* toUnit, int* result = NULL);
-
-        // place the information from this object into the xml library 'lib'
-        // virtual RpNumber& put(RpLibrary lib);
-        RpNumber& put() const;
-        RpNumber& put(double currentVal);
-
-
-
-        /*
-         * user provides a 'path' for where this object lives in xml file
-         * user calls define with standard hints as described in Number docs
-         *  'units' - string providing units of the number
-         *  'defaultVal' - numeric value to be used if user provides no value
-         *  'min' - (optional) minimum allowed value
-         *  'max' - (optional) maximum allowed value
-         *  'label' - (optional) name of the input for a gui field
-         *  'desc' - (optional) description of the input for the gui
-         *
-         *  Notes: 
-         *      if the user sets a min or max value the following applies:
-         *          if the value of min is greater than the value of default,
-         *          then min will be set to default
-         *
-         *          if the value of max is less than the value of default, 
-         *          then max will be set to default.
-         *
-         *
-         *
-         */
-
-        /* what about unit-less numbers */
-        RpNumber (
-                    std::string path, 
-                    std::string units,
-                    double defaultVal
-                )
-            :   RpVariable  (path, new double (defaultVal) ),
-                // units       (units),
-                min         (0),
-                max         (0),
-                minmaxSet   (0)
-        {
-            this->units = RpUnits::find(units);
-            if (! this->units) {
-                this->units = RpUnits::define(units,NULL);
-            }
-        }
-
-        RpNumber (
-                    std::string path, 
-                    std::string units,
-                    double defaultVal,
+        RpNumber (  const char *path,
+                    const char *unit,
+                    double val,
                     double min,
                     double max,
-                    std::string label,
-                    std::string desc
-                )
-            :   RpVariable  (path, new double (defaultVal), label, desc),
-                // units       (units),
-                min         (min),
-                max         (max),
-                minmaxSet   (0)
-        { 
+                    const char *label,
+                    const char *desc);
 
-            this->units = RpUnits::find(units);
-            if (! this->units) {
-                this->units = RpUnits::define(units,NULL);
-            }
+        RpNumber ( const RpNumber& o );
+        virtual ~RpNumber ();
 
-            if ((min == 0) && (max == 0)) {
-                minmaxSet = 0;
-            }
-            else {
+        virtual const double defaultValue    (double val);
+        virtual const double currentValue    (double val);
+        virtual const double min             (double val);
+        virtual const double max             (double val);
+        virtual const char *units            (const char *val);
+        // need to add a way to tell user conversion failed
+        virtual double convert               (const char *to);
 
-                if (min > defaultVal) {
-                    this->min = defaultVal;
-                }
-
-                if (max < defaultVal) {
-                    this->max = defaultVal;
-                }
-            }
-
-        }
-
-        // copy constructor
-        RpNumber ( const RpNumber& myRpNumber )
-            :   RpVariable(myRpNumber),
-                units       (myRpNumber.units),
-                min         (myRpNumber.min),
-                max         (myRpNumber.max),
-                minmaxSet   (myRpNumber.minmaxSet)
-        {}
-
-        // default destructor
-        // virtual ~RpNumber ()
-        virtual ~RpNumber ()
-        {
-            // clean up dynamic memory
-
-        }
     private:
 
-        // std::string units;
-        const RpUnits* units;
-        double min;
-        double max;
+        double _default;
+        double _current;
+        double _min;
+        double _max;
 
-        // flag to tell if the user specified the min and max values 
-        int minmaxSet;
-
+        // flag tells if user specified min and max values
+        int _minmaxSet;
 };
 
Index: /trunk/src/objects/RpPool.c
===================================================================
--- /trunk/src/objects/RpPool.c	(revision 1270)
+++ /trunk/src/objects/RpPool.c	(revision 1270)
@@ -0,0 +1,458 @@
+/*
+ * bltPool.c --
+ *
+ * Copyright 2001 Silicon Metrics, Inc.
+ *
+ * Permission to use, copy, modify, and distribute this software and
+ * its documentation for any purpose and without fee is hereby
+ * granted, provided that the above copyright notice appear in all
+ * copies and that both that the copyright notice and warranty
+ * disclaimer appear in supporting documentation, and that the names
+ * of Lucent Technologies any of their entities not be used in
+ * advertising or publicity pertaining to distribution of the software
+ * without specific, written prior permission.
+ *
+ * Silicon Metrics disclaims all warranties with regard to this
+ * software, including all implied warranties of merchantability and
+ * fitness.  In no event shall Lucent Technologies be liable for any
+ * special, indirect or consequential damages or any damages
+ * whatsoever resulting from loss of use, data or profits, whether in
+ * an action of contract, negligence or other tortuous action, arising
+ * out of or in connection with the use or performance of this
+ * software.
+ */
+
+#include "RpInt.h"
+#include "RpPool.h"
+
+/*
+ * Rp_Pool --
+ *
+ *  Implements a pool memory allocator.
+ *
+ *    + It's faster allocating memory since malloc/free are called
+ *      only a fraction of the normal times.  Fixed size items can
+ *      be reused without deallocating/reallocating memory.
+ *    + You don't have the extra 8-16 byte overhead per malloc.
+ *    - Memory is freed only when the entire pool is destroyed.
+ *    - Memory is allocated in chunks. More memory is allocated
+ *      than used.
+ *    0 Depending upon allocation/deallocation patterns, locality
+ *      may be improved or degraded.
+ *
+ *      The pool is a chain of malloc'ed blocks.
+ *
+ *             +---------+  +---------+  +---------+
+ *       NULL<-| nextPtr |<-| nextPtr |<-| nextPtr |<- headPtr
+ *             |---------|  |---------|  |---------|
+ *             | chunk1  |  | chunk2  |  | chunk3  |
+ *             +---------+  |         |  |         |
+ *                          +---------+  |         |
+ *                                       |         |
+ *                                       |         |
+ *                                       +---------+
+ *
+ *      Each chunk contains an integral number of fixed size items.
+ *      The number of items doubles until a maximum size is reached
+ *      (each subsequent new chunk will be the maximum).  Chunks
+ *      are allocated only when needed (no more space is available
+ *      in the last chunk).
+ *
+ *      The chain of blocks is only freed when the entire pool is
+ *      destroyed.
+ *
+ *      A freelist of unused items also maintained. Each freed item
+ *      is prepended to a free list.  Before allocating new chunks
+ *      the freelist is examined to see if an unused items exist.
+ *
+ *               chunk1       chunk2       chunk3
+ *            +---------+  +---------+  +---------+
+ *      NULL<-| unused  |  |         |  |         |
+ *            +----^----+  +---------+  +---------+
+ *            | unused  |<-| unused  |<-| unused  |
+ *            +---------+  +---------+  +----^----+
+ *            |         |  |         |  | unused  |
+ *            +---------+  |         |  +----^----+
+ *                         |         |  |    |    |
+ *                         +---------+  +----|----+
+ *                                      | usused  |<- freePtr
+ *                                      +---------+
+ */
+
+#define POOL_MAX_CHUNK_SIZE      ((1<<16) - sizeof(Rp_PoolChain))
+
+#ifndef ALIGN
+#define ALIGN(a) \
+    (((size_t)a + (sizeof(void *) - 1)) & (~(sizeof(void *) - 1)))
+#endif /* ALIGN */
+
+static Rp_PoolAllocProc VariablePoolAllocItem;
+static Rp_PoolFreeProc  VariablePoolFreeItem;
+static Rp_PoolAllocProc FixedPoolAllocItem;
+static Rp_PoolFreeProc  FixedPoolFreeItem;
+static Rp_PoolAllocProc StringPoolAllocItem;
+static Rp_PoolFreeProc  StringPoolFreeItem;
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * VariablePoolAllocItem --
+ *
+ *      Returns a new item.  First check if there is any more space
+ *      left in the current chunk.  If there isn't then next check
+ *      the free list for unused items.  Finally allocate a new
+ *      chunk and return its first item.
+ *
+ * Results:
+ *      Returns a new (possible reused) item.
+ *
+ * Side Effects:
+ *      A new memory chunk may be allocated.
+ *
+ *----------------------------------------------------------------------
+ */
+static void *
+VariablePoolAllocItem(poolPtr, size)
+    struct Rp_PoolStruct *poolPtr;
+    size_t size;    /* Number of bytes to allocate. */
+{
+    Rp_PoolChain *chainPtr;
+    void *memPtr;
+
+    size = ALIGN(size);
+    if (size >= POOL_MAX_CHUNK_SIZE) {
+    /*
+     * Handle oversized requests by allocating a chunk to hold the
+     * single item and immediately placing it into the in-use list.
+     */
+        chainPtr = malloc(sizeof(Rp_PoolChain) + size);
+        if (poolPtr->headPtr == NULL) {
+            poolPtr->headPtr = chainPtr;
+        } else {
+            chainPtr->nextPtr = poolPtr->headPtr->nextPtr;
+            poolPtr->headPtr->nextPtr = chainPtr;
+        }
+        memPtr = (void *)chainPtr;
+    } else {
+        if (poolPtr->bytesLeft >= size) {
+            poolPtr->bytesLeft -= size;
+            memPtr = (char *)(poolPtr->headPtr + 1) + poolPtr->bytesLeft;
+        } else {
+            poolPtr->waste += poolPtr->bytesLeft;
+            /* Create a new block of items and prepend it to the in-use list */
+            poolPtr->bytesLeft = POOL_MAX_CHUNK_SIZE;
+            /* Allocate the requested chunk size, plus the header */
+            chainPtr = malloc(sizeof(Rp_PoolChain) + poolPtr->bytesLeft);
+            chainPtr->nextPtr = poolPtr->headPtr;
+            poolPtr->headPtr = chainPtr;
+            /* Peel off a new item. */
+            poolPtr->bytesLeft -= size;
+            memPtr = (char *)(chainPtr + 1) + poolPtr->bytesLeft;
+        }
+    }
+    return memPtr;
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * VariablePoolFreeItem --
+ *
+ *      Placeholder for freeProc routine.  The pool memory is
+ *      not reclaimed or freed until the entire pool is released.
+ *
+ * Results:
+ *      None.
+ *
+ *----------------------------------------------------------------------
+ */
+/*ARGSUSED*/
+static void
+VariablePoolFreeItem(poolPtr, item)
+    struct Rp_PoolStruct *poolPtr;
+    void *item;
+{
+    /* Does nothing */
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * StringPoolAllocItem --
+ *
+ *      Returns a new item.  First check if there is any more space
+ *      left in the current chunk.  If there isn't then next check
+ *      the free list for unused items.  Finally allocate a new
+ *      chunk and return its first item.
+ *
+ * Results:
+ *      Returns a new (possible reused) item.
+ *
+ * Side Effects:
+ *      A new memory chunk may be allocated.
+ *
+ *----------------------------------------------------------------------
+ */
+static void *
+StringPoolAllocItem(poolPtr, size)
+    struct Rp_PoolStruct *poolPtr;
+    size_t size;        /* Number of bytes to allocate. */
+{
+    Rp_PoolChain *chainPtr;
+    void *memPtr;
+
+    if (size >= POOL_MAX_CHUNK_SIZE) {
+        /*
+         * Handle oversized requests by allocating a chunk to hold the
+         * single item and immediately placing it into the in-use list.
+         */
+        chainPtr = malloc(sizeof(Rp_PoolChain) + size);
+        if (poolPtr->headPtr == NULL) {
+            poolPtr->headPtr = chainPtr;
+        } else {
+            chainPtr->nextPtr = poolPtr->headPtr->nextPtr;
+            poolPtr->headPtr->nextPtr = chainPtr;
+        }
+        memPtr = (void *)chainPtr;
+    } else {
+        if (poolPtr->bytesLeft >= size) {
+            poolPtr->bytesLeft -= size;
+            memPtr = (char *)(poolPtr->headPtr + 1) + poolPtr->bytesLeft;
+        } else {
+            poolPtr->waste += poolPtr->bytesLeft;
+            /* Create a new block of items and prepend it to the
+             * in-use list */
+            poolPtr->bytesLeft = POOL_MAX_CHUNK_SIZE;
+            /* Allocate the requested chunk size, plus the header */
+            chainPtr = malloc(sizeof(Rp_PoolChain) + poolPtr->bytesLeft);
+            chainPtr->nextPtr = poolPtr->headPtr;
+            poolPtr->headPtr = chainPtr;
+            /* Peel off a new item. */
+            poolPtr->bytesLeft -= size;
+            memPtr = (char *)(chainPtr + 1) + poolPtr->bytesLeft;
+        }
+    }
+    return memPtr;
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * StringPoolFreeItem --
+ *
+ *      Placeholder for freeProc routine.  String pool memory is
+ *      not reclaimed or freed until the entire pool is released.
+ *
+ * Results:
+ *      None.
+ *
+ *----------------------------------------------------------------------
+ */
+/*ARGSUSED*/
+static void
+StringPoolFreeItem(poolPtr, item)
+    struct Rp_PoolStruct *poolPtr;
+    void *item;
+{
+    /* Does nothing */
+}
+
+/*
+ *       The fixed size pool is a chain of malloc'ed blocks.
+ *
+ *             +---------+  +---------+  +---------+
+ *       NULL<-| nextPtr |<-| nextPtr |<-| nextPtr |<- headPtr
+ *             |---------|  |---------|  |---------|
+ *             | chunk1  |  | chunk2  |  | chunk3  |
+ *             +---------+  |         |  |         |
+ *                          +---------+  |         |
+ *                                       |         |
+ *                                       |         |
+ *                                       +---------+
+ *
+ *      Each chunk contains an integral number of fixed size items.
+ *      The number of items doubles until a maximum size is reached
+ *      (each subsequent new chunk will be the maximum).  Chunks
+ *      are allocated only when needed (no more space is available
+ *      in the last chunk).
+ *
+ *      The chain of blocks is only freed when the entire pool is
+ *      destroyed.
+ *
+ *      A freelist of unused items also maintained. Each freed item
+ *      is prepended to a free list.  Before allocating new chunks
+ *      the freelist is examined to see if an unused items exist.
+ *
+ *               chunk1       chunk2       chunk3
+ *            +---------+  +---------+  +---------+
+ *      NULL<-| unused  |  |         |  |         |
+ *            +----^----+  +---------+  +---------+
+ *            | unused  |<-| unused  |<-| unused  |
+ *            +---------+  +---------+  +----^----+
+ *            |         |  |         |  | unused  |
+ *            +---------+  |         |  +----^----+
+ *                         |         |  |    |    |
+ *                         +---------+  +----|----+
+ *                                      | usused  |<- freePtr
+ *                                      +---------+
+ */
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * FixedPoolFreeItem --
+ *
+ *      Returns a new item.  First check if there is any more space
+ *      left in the current chunk.  If there isn't then next check
+ *      the free list for unused items.  Finally allocate a new
+ *      chunk and return its first item.
+ *
+ * Results:
+ *      Returns a new (possible reused) item.
+ *
+ * Side Effects:
+ *      A new memory chunk may be allocated.
+ *
+ *----------------------------------------------------------------------
+ */
+static void *
+FixedPoolAllocItem(poolPtr, size)
+    struct Rp_PoolStruct *poolPtr;
+    size_t size;
+{
+    Rp_PoolChain *chainPtr;
+    void *newPtr;
+
+    size = ALIGN(size);
+    if (poolPtr->itemSize == 0) {
+        poolPtr->itemSize = size;
+    }
+    assert(size == poolPtr->itemSize);
+
+    if (poolPtr->bytesLeft > 0) {
+        poolPtr->bytesLeft -= poolPtr->itemSize;
+        newPtr = (char *)(poolPtr->headPtr + 1) + poolPtr->bytesLeft;
+    } else if (poolPtr->freePtr != NULL) { /* Reuse from the free list. */
+        /* Reuse items on the free list */
+        chainPtr = poolPtr->freePtr;
+        poolPtr->freePtr = chainPtr->nextPtr;
+        newPtr = (void *)chainPtr;
+    } else {            /* Allocate another block. */
+
+        /* Create a new block of items and prepend it to the in-use list */
+        poolPtr->bytesLeft = poolPtr->itemSize * (1 << poolPtr->poolSize);
+        if (poolPtr->bytesLeft < POOL_MAX_CHUNK_SIZE) {
+            poolPtr->poolSize++; /* Keep doubling the size of the new
+                                  * chunk up to a maximum size. */
+        }
+        /* Allocate the requested chunk size, plus the header */
+        chainPtr = malloc(sizeof(Rp_PoolChain) + poolPtr->bytesLeft);
+        chainPtr->nextPtr = poolPtr->headPtr;
+        poolPtr->headPtr = chainPtr;
+
+        /* Peel off a new item. */
+        poolPtr->bytesLeft -= poolPtr->itemSize;
+        newPtr = (char *)(poolPtr->headPtr + 1) + poolPtr->bytesLeft;
+    }
+    return newPtr;
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * FixedPoolFreeItem --
+ *
+ *      Frees an item.  The actual memory is not freed.  The item
+ *      instead is prepended to a freelist where it may be reclaimed
+ *      and used again.
+ *
+ * Results:
+ *      None.
+ *
+ * Side Effects:
+ *      Item is placed on the pool's free list.
+ *
+ *----------------------------------------------------------------------
+ */
+static void
+FixedPoolFreeItem(poolPtr, item)
+    struct Rp_PoolStruct *poolPtr;
+    void *item;
+{
+    Rp_PoolChain *chainPtr = (Rp_PoolChain *)item;
+
+    /* Prepend the newly deallocated item to the free list. */
+    chainPtr->nextPtr = poolPtr->freePtr;
+    poolPtr->freePtr = chainPtr;
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Rp_PoolCreate --
+ *
+ *      Creates a new memory pool for fixed-size/variable-size/string
+ *      items.
+ *
+ * Results:
+ *      Returns a pointer to the newly allocated pool.
+ *
+ *---------------------------------------------------------------------- 
+ */
+
+Rp_Pool
+Rp_PoolCreate(type)
+    int type;
+{
+    struct Rp_PoolStruct *poolPtr;
+
+    poolPtr = malloc(sizeof(struct Rp_PoolStruct));
+    switch (type) {
+    case RP_VARIABLE_SIZE_ITEMS:
+        poolPtr->allocProc = VariablePoolAllocItem;
+        poolPtr->freeProc = VariablePoolFreeItem;
+        break;
+    case RP_FIXED_SIZE_ITEMS:
+        poolPtr->allocProc = FixedPoolAllocItem;
+        poolPtr->freeProc = FixedPoolFreeItem;
+        break;
+    case RP_STRING_ITEMS:
+        poolPtr->allocProc = StringPoolAllocItem;
+        poolPtr->freeProc = StringPoolFreeItem;
+        break;
+    }
+    poolPtr->headPtr = poolPtr->freePtr = NULL;
+    poolPtr->waste = poolPtr->bytesLeft = 0;
+    poolPtr->poolSize = poolPtr->itemSize = 0;
+    return poolPtr;
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Rp_PoolDestroy --
+ *
+ *      Destroys the given memory pool.  The chain of allocated blocks
+ *      are freed.  The is the only time that memory is actually freed.
+ *
+ * Results:
+ *      None.
+ *
+ * Side Effects:
+ *      All memory used by the pool is freed.
+ *
+ *----------------------------------------------------------------------
+ */
+void
+Rp_PoolDestroy(poolPtr)
+    struct Rp_PoolStruct *poolPtr;
+{
+    register Rp_PoolChain *chainPtr, *nextPtr;
+
+    for (chainPtr = poolPtr->headPtr; chainPtr != NULL; chainPtr = nextPtr) {
+        nextPtr = chainPtr->nextPtr;
+        free(chainPtr);
+    }
+    free(poolPtr);
+}
+
